#include <Wire.h>
#include "RTClib.h"
#include <LiquidCrystal_I2C.h>
RTC_DS1307 rtc;
LiquidCrystal_I2C lcd(0x27,16,2);

byte LT[8] = { B00111,B01111,B11110,B11110,B11110,B11110,B01111,B00111 };
byte UB[8] = { B11111,B11111,B00000,B00000,B00000,B00000,B00000,B00000 };
byte RT[8] = { B11100,B11110,B01111,B01111,B01111,B01111,B11110,B11100 };
byte LL[8] = { B11100,B11100,B00000,B00000,B00000,B00000,B10000,B11000 };
byte LB[8] = { B00000,B00000,B00000,B00000,B00000,B00000,B11111,B11111 };
byte LR[8] = { B00111,B00111,B00000,B00000,B00000,B00000,B00001,B00011 };
byte MB[8] = { B11111,B11111,B00000,B00000,B00000,B00000,B11111,B11111 };
byte block[8] = { B01110,B01110,B11111,B11111,B11111,B11111,B01110,B01110 };
int count = 0;



void setup () {
  Serial.begin(57600);
  Wire.begin();
  rtc.begin();
  lcd.init();
  lcd.backlight();
  lcd.home();

  lcd.createChar(0,LT);
  lcd.createChar(1,UB);
  lcd.createChar(2,RT);
  lcd.createChar(3,LL);
  lcd.createChar(4,LB);
  lcd.createChar(5,LR);
  lcd.createChar(6,MB);
  lcd.createChar(7,block);

  lcd.clear();  



  if (! rtc.isrunning()) {
    Serial.println("RTC is NOT running!");
  }
}



void custom0(int x)
{

  lcd.setCursor(x,0);
  lcd.write(7);
  lcd.write(1);
  lcd.write(7);
  lcd.setCursor(x, 1);
  lcd.write(7);
  lcd.write(4);
  lcd.write(7);
}

void custom1(int x)
{
  lcd.setCursor(x,0);
  lcd.write(1);
  lcd.write(7);
  lcd.print(" ");
  lcd.setCursor(x,1);
  lcd.write(4);
  lcd.write(7);
  lcd.write(4);
}

void custom2(int x)
{
  lcd.setCursor(x,0);
  lcd.write(5);
  lcd.write(6);
  lcd.write(2);
  lcd.setCursor(x, 1);
  lcd.write(0);
  lcd.write(4);
  lcd.write(4);
}

void custom3(int x)
{
  lcd.setCursor(x,0);
  lcd.write(1);
  lcd.write(6);
  lcd.write(2);
  lcd.setCursor(x, 1);
  lcd.write(4);
  lcd.write(4);
  lcd.write(2); 
}

void custom4(int x)
{
  lcd.setCursor(x,0);
  lcd.write(7);
  lcd.write(4);
  lcd.write(7);
  lcd.setCursor(x, 1);
  lcd.print(" ");
  lcd.print(" ");
  lcd.write(7);
}

void custom5(int x)
{
  lcd.setCursor(x,0);
  lcd.write(0);
  lcd.write(6);
  lcd.write(3);
  lcd.setCursor(x, 1);
  lcd.write(4);
  lcd.write(4);
  lcd.write(2);
}

void custom6(int x)
{
  lcd.setCursor(x,0);
  lcd.write(0);
  lcd.write(6);
  lcd.write(3);
  lcd.setCursor(x, 1);
  lcd.write(7);
  lcd.write(4);
  lcd.write(2);
}

void custom7(int x)
{
  lcd.setCursor(x,0);
  lcd.write(1);
  lcd.write(1);
  lcd.write(7);
  lcd.setCursor(x, 1);
  lcd.print(" ");
  lcd.print(" ");
  lcd.write(7);
}

void custom8(int x)
{
  lcd.setCursor(x,0);
  lcd.write(0);
  lcd.write(6);
  lcd.write(2);
  lcd.setCursor(x, 1);
  lcd.write(0);
  lcd.write(4);
  lcd.write(2);
}

void custom9(int x)
{
  lcd.setCursor(x,0);
  lcd.write(0);
  lcd.write(6);
  lcd.write(7);
  lcd.setCursor(x, 1);
  lcd.write(4);
  lcd.write(4);
  lcd.write(2);

}

void loop () {

  digitalClockDisplay();  
  delay(1000);

}


void digitalClockDisplay(){
  DateTime now = rtc.now();

  printDigits(now.hour()/10,0); 
  printDigits(now.hour()%10,4); 

  printDigits(now.minute()/10,9);
  printDigits(now.minute()%10,13);



  if (now.second()%10%2==0){
    lcd.setCursor(7, 0);
    lcd.print("* ");
    lcd.setCursor(7, 1);
    lcd.print(" *");
  }
  else
  {
    lcd.setCursor(7, 0);
    lcd.print(" *");
    lcd.setCursor(7, 1);
    lcd.print("* ");
  }

}



void printDigits(int digits, int x){

  switch (digits) {
  case 0:  
    custom0(x);
    break;
  case 1:  
    custom1(x);
    break;
  case 2:  
    custom2(x);
    break;
  case 3:  
    custom3(x);
    break;
  case 4:  
    custom4(x);
    break;
  case 5:  
    custom5(x);
    break;
  case 6:  
    custom6(x);
    break;
  case 7:  
    custom7(x);
    break;
  case 8:  
    custom8(x);
    break;
  case 9:  
    custom9(x);
    break;

  }



}
